package org.xtextcomponentMM_v2.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.xtextcomponentMM_v2.services.Mmv2GrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalMmv2Parser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_STRING", "RULE_ID", "RULE_INT", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'CC'", "'{'", "'ports'", "','", "'}'", "'intComponents'", "'intConnectors'", "'Connector'", "'->'", "'RI'", "'PI'", "'SC'"
    };
    public static final int RULE_ID=5;
    public static final int T__22=22;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__21=21;
    public static final int T__20=20;
    public static final int RULE_SL_COMMENT=8;
    public static final int EOF=-1;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__19=19;
    public static final int RULE_STRING=4;
    public static final int T__16=16;
    public static final int T__15=15;
    public static final int T__18=18;
    public static final int T__17=17;
    public static final int T__12=12;
    public static final int T__11=11;
    public static final int T__14=14;
    public static final int T__13=13;
    public static final int RULE_INT=6;
    public static final int RULE_WS=9;

    // delegates
    // delegators


        public InternalMmv2Parser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalMmv2Parser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalMmv2Parser.tokenNames; }
    public String getGrammarFileName() { return "../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g"; }



     	private Mmv2GrammarAccess grammarAccess;
     	
        public InternalMmv2Parser(TokenStream input, Mmv2GrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "ComplexComponent";	
       	}
       	
       	@Override
       	protected Mmv2GrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleComplexComponent"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:67:1: entryRuleComplexComponent returns [EObject current=null] : iv_ruleComplexComponent= ruleComplexComponent EOF ;
    public final EObject entryRuleComplexComponent() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleComplexComponent = null;


        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:68:2: (iv_ruleComplexComponent= ruleComplexComponent EOF )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:69:2: iv_ruleComplexComponent= ruleComplexComponent EOF
            {
             newCompositeNode(grammarAccess.getComplexComponentRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleComplexComponent_in_entryRuleComplexComponent75);
            iv_ruleComplexComponent=ruleComplexComponent();

            state._fsp--;

             current =iv_ruleComplexComponent; 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleComplexComponent85); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleComplexComponent"


    // $ANTLR start "ruleComplexComponent"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:76:1: ruleComplexComponent returns [EObject current=null] : (otherlv_0= 'CC' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' otherlv_3= 'ports' otherlv_4= '{' ( (lv_ports_5_0= rulePort ) ) (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )? otherlv_8= '}' otherlv_9= 'intComponents' otherlv_10= '{' ( (lv_internalComponents_11_0= ruleComponent ) ) (otherlv_12= ',' ( (lv_internalComponents_13_0= ruleComponent ) ) )* otherlv_14= '}' otherlv_15= 'intConnectors' otherlv_16= '{' ( (lv_internalConnectors_17_0= ruleConnector ) ) (otherlv_18= ',' ( (lv_internalConnectors_19_0= ruleConnector ) ) )* otherlv_20= '}' otherlv_21= '}' ) ;
    public final EObject ruleComplexComponent() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        Token otherlv_8=null;
        Token otherlv_9=null;
        Token otherlv_10=null;
        Token otherlv_12=null;
        Token otherlv_14=null;
        Token otherlv_15=null;
        Token otherlv_16=null;
        Token otherlv_18=null;
        Token otherlv_20=null;
        Token otherlv_21=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;

        EObject lv_ports_5_0 = null;

        EObject lv_ports_7_0 = null;

        EObject lv_internalComponents_11_0 = null;

        EObject lv_internalComponents_13_0 = null;

        EObject lv_internalConnectors_17_0 = null;

        EObject lv_internalConnectors_19_0 = null;


         enterRule(); 
            
        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:79:28: ( (otherlv_0= 'CC' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' otherlv_3= 'ports' otherlv_4= '{' ( (lv_ports_5_0= rulePort ) ) (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )? otherlv_8= '}' otherlv_9= 'intComponents' otherlv_10= '{' ( (lv_internalComponents_11_0= ruleComponent ) ) (otherlv_12= ',' ( (lv_internalComponents_13_0= ruleComponent ) ) )* otherlv_14= '}' otherlv_15= 'intConnectors' otherlv_16= '{' ( (lv_internalConnectors_17_0= ruleConnector ) ) (otherlv_18= ',' ( (lv_internalConnectors_19_0= ruleConnector ) ) )* otherlv_20= '}' otherlv_21= '}' ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:80:1: (otherlv_0= 'CC' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' otherlv_3= 'ports' otherlv_4= '{' ( (lv_ports_5_0= rulePort ) ) (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )? otherlv_8= '}' otherlv_9= 'intComponents' otherlv_10= '{' ( (lv_internalComponents_11_0= ruleComponent ) ) (otherlv_12= ',' ( (lv_internalComponents_13_0= ruleComponent ) ) )* otherlv_14= '}' otherlv_15= 'intConnectors' otherlv_16= '{' ( (lv_internalConnectors_17_0= ruleConnector ) ) (otherlv_18= ',' ( (lv_internalConnectors_19_0= ruleConnector ) ) )* otherlv_20= '}' otherlv_21= '}' )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:80:1: (otherlv_0= 'CC' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' otherlv_3= 'ports' otherlv_4= '{' ( (lv_ports_5_0= rulePort ) ) (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )? otherlv_8= '}' otherlv_9= 'intComponents' otherlv_10= '{' ( (lv_internalComponents_11_0= ruleComponent ) ) (otherlv_12= ',' ( (lv_internalComponents_13_0= ruleComponent ) ) )* otherlv_14= '}' otherlv_15= 'intConnectors' otherlv_16= '{' ( (lv_internalConnectors_17_0= ruleConnector ) ) (otherlv_18= ',' ( (lv_internalConnectors_19_0= ruleConnector ) ) )* otherlv_20= '}' otherlv_21= '}' )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:80:3: otherlv_0= 'CC' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' otherlv_3= 'ports' otherlv_4= '{' ( (lv_ports_5_0= rulePort ) ) (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )? otherlv_8= '}' otherlv_9= 'intComponents' otherlv_10= '{' ( (lv_internalComponents_11_0= ruleComponent ) ) (otherlv_12= ',' ( (lv_internalComponents_13_0= ruleComponent ) ) )* otherlv_14= '}' otherlv_15= 'intConnectors' otherlv_16= '{' ( (lv_internalConnectors_17_0= ruleConnector ) ) (otherlv_18= ',' ( (lv_internalConnectors_19_0= ruleConnector ) ) )* otherlv_20= '}' otherlv_21= '}'
            {
            otherlv_0=(Token)match(input,11,FollowSets000.FOLLOW_11_in_ruleComplexComponent122); 

                	newLeafNode(otherlv_0, grammarAccess.getComplexComponentAccess().getCCKeyword_0());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:84:1: ( (lv_name_1_0= ruleEString ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:85:1: (lv_name_1_0= ruleEString )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:85:1: (lv_name_1_0= ruleEString )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:86:3: lv_name_1_0= ruleEString
            {
             
            	        newCompositeNode(grammarAccess.getComplexComponentAccess().getNameEStringParserRuleCall_1_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleEString_in_ruleComplexComponent143);
            lv_name_1_0=ruleEString();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getComplexComponentRule());
            	        }
                   		set(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"EString");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_2=(Token)match(input,12,FollowSets000.FOLLOW_12_in_ruleComplexComponent155); 

                	newLeafNode(otherlv_2, grammarAccess.getComplexComponentAccess().getLeftCurlyBracketKeyword_2());
                
            otherlv_3=(Token)match(input,13,FollowSets000.FOLLOW_13_in_ruleComplexComponent167); 

                	newLeafNode(otherlv_3, grammarAccess.getComplexComponentAccess().getPortsKeyword_3());
                
            otherlv_4=(Token)match(input,12,FollowSets000.FOLLOW_12_in_ruleComplexComponent179); 

                	newLeafNode(otherlv_4, grammarAccess.getComplexComponentAccess().getLeftCurlyBracketKeyword_4());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:114:1: ( (lv_ports_5_0= rulePort ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:115:1: (lv_ports_5_0= rulePort )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:115:1: (lv_ports_5_0= rulePort )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:116:3: lv_ports_5_0= rulePort
            {
             
            	        newCompositeNode(grammarAccess.getComplexComponentAccess().getPortsPortParserRuleCall_5_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_rulePort_in_ruleComplexComponent200);
            lv_ports_5_0=rulePort();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getComplexComponentRule());
            	        }
                   		add(
                   			current, 
                   			"ports",
                    		lv_ports_5_0, 
                    		"Port");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:132:2: (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )?
            int alt1=2;
            int LA1_0 = input.LA(1);

            if ( (LA1_0==14) ) {
                alt1=1;
            }
            switch (alt1) {
                case 1 :
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:132:4: otherlv_6= ',' ( (lv_ports_7_0= rulePort ) )
                    {
                    otherlv_6=(Token)match(input,14,FollowSets000.FOLLOW_14_in_ruleComplexComponent213); 

                        	newLeafNode(otherlv_6, grammarAccess.getComplexComponentAccess().getCommaKeyword_6_0());
                        
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:136:1: ( (lv_ports_7_0= rulePort ) )
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:137:1: (lv_ports_7_0= rulePort )
                    {
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:137:1: (lv_ports_7_0= rulePort )
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:138:3: lv_ports_7_0= rulePort
                    {
                     
                    	        newCompositeNode(grammarAccess.getComplexComponentAccess().getPortsPortParserRuleCall_6_1_0()); 
                    	    
                    pushFollow(FollowSets000.FOLLOW_rulePort_in_ruleComplexComponent234);
                    lv_ports_7_0=rulePort();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getComplexComponentRule());
                    	        }
                           		add(
                           			current, 
                           			"ports",
                            		lv_ports_7_0, 
                            		"Port");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }


                    }
                    break;

            }

            otherlv_8=(Token)match(input,15,FollowSets000.FOLLOW_15_in_ruleComplexComponent248); 

                	newLeafNode(otherlv_8, grammarAccess.getComplexComponentAccess().getRightCurlyBracketKeyword_7());
                
            otherlv_9=(Token)match(input,16,FollowSets000.FOLLOW_16_in_ruleComplexComponent260); 

                	newLeafNode(otherlv_9, grammarAccess.getComplexComponentAccess().getIntComponentsKeyword_8());
                
            otherlv_10=(Token)match(input,12,FollowSets000.FOLLOW_12_in_ruleComplexComponent272); 

                	newLeafNode(otherlv_10, grammarAccess.getComplexComponentAccess().getLeftCurlyBracketKeyword_9());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:166:1: ( (lv_internalComponents_11_0= ruleComponent ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:167:1: (lv_internalComponents_11_0= ruleComponent )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:167:1: (lv_internalComponents_11_0= ruleComponent )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:168:3: lv_internalComponents_11_0= ruleComponent
            {
             
            	        newCompositeNode(grammarAccess.getComplexComponentAccess().getInternalComponentsComponentParserRuleCall_10_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleComponent_in_ruleComplexComponent293);
            lv_internalComponents_11_0=ruleComponent();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getComplexComponentRule());
            	        }
                   		add(
                   			current, 
                   			"internalComponents",
                    		lv_internalComponents_11_0, 
                    		"Component");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:184:2: (otherlv_12= ',' ( (lv_internalComponents_13_0= ruleComponent ) ) )*
            loop2:
            do {
                int alt2=2;
                int LA2_0 = input.LA(1);

                if ( (LA2_0==14) ) {
                    alt2=1;
                }


                switch (alt2) {
            	case 1 :
            	    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:184:4: otherlv_12= ',' ( (lv_internalComponents_13_0= ruleComponent ) )
            	    {
            	    otherlv_12=(Token)match(input,14,FollowSets000.FOLLOW_14_in_ruleComplexComponent306); 

            	        	newLeafNode(otherlv_12, grammarAccess.getComplexComponentAccess().getCommaKeyword_11_0());
            	        
            	    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:188:1: ( (lv_internalComponents_13_0= ruleComponent ) )
            	    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:189:1: (lv_internalComponents_13_0= ruleComponent )
            	    {
            	    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:189:1: (lv_internalComponents_13_0= ruleComponent )
            	    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:190:3: lv_internalComponents_13_0= ruleComponent
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getComplexComponentAccess().getInternalComponentsComponentParserRuleCall_11_1_0()); 
            	    	    
            	    pushFollow(FollowSets000.FOLLOW_ruleComponent_in_ruleComplexComponent327);
            	    lv_internalComponents_13_0=ruleComponent();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getComplexComponentRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"internalComponents",
            	            		lv_internalComponents_13_0, 
            	            		"Component");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop2;
                }
            } while (true);

            otherlv_14=(Token)match(input,15,FollowSets000.FOLLOW_15_in_ruleComplexComponent341); 

                	newLeafNode(otherlv_14, grammarAccess.getComplexComponentAccess().getRightCurlyBracketKeyword_12());
                
            otherlv_15=(Token)match(input,17,FollowSets000.FOLLOW_17_in_ruleComplexComponent353); 

                	newLeafNode(otherlv_15, grammarAccess.getComplexComponentAccess().getIntConnectorsKeyword_13());
                
            otherlv_16=(Token)match(input,12,FollowSets000.FOLLOW_12_in_ruleComplexComponent365); 

                	newLeafNode(otherlv_16, grammarAccess.getComplexComponentAccess().getLeftCurlyBracketKeyword_14());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:218:1: ( (lv_internalConnectors_17_0= ruleConnector ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:219:1: (lv_internalConnectors_17_0= ruleConnector )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:219:1: (lv_internalConnectors_17_0= ruleConnector )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:220:3: lv_internalConnectors_17_0= ruleConnector
            {
             
            	        newCompositeNode(grammarAccess.getComplexComponentAccess().getInternalConnectorsConnectorParserRuleCall_15_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleConnector_in_ruleComplexComponent386);
            lv_internalConnectors_17_0=ruleConnector();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getComplexComponentRule());
            	        }
                   		add(
                   			current, 
                   			"internalConnectors",
                    		lv_internalConnectors_17_0, 
                    		"Connector");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:236:2: (otherlv_18= ',' ( (lv_internalConnectors_19_0= ruleConnector ) ) )*
            loop3:
            do {
                int alt3=2;
                int LA3_0 = input.LA(1);

                if ( (LA3_0==14) ) {
                    alt3=1;
                }


                switch (alt3) {
            	case 1 :
            	    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:236:4: otherlv_18= ',' ( (lv_internalConnectors_19_0= ruleConnector ) )
            	    {
            	    otherlv_18=(Token)match(input,14,FollowSets000.FOLLOW_14_in_ruleComplexComponent399); 

            	        	newLeafNode(otherlv_18, grammarAccess.getComplexComponentAccess().getCommaKeyword_16_0());
            	        
            	    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:240:1: ( (lv_internalConnectors_19_0= ruleConnector ) )
            	    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:241:1: (lv_internalConnectors_19_0= ruleConnector )
            	    {
            	    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:241:1: (lv_internalConnectors_19_0= ruleConnector )
            	    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:242:3: lv_internalConnectors_19_0= ruleConnector
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getComplexComponentAccess().getInternalConnectorsConnectorParserRuleCall_16_1_0()); 
            	    	    
            	    pushFollow(FollowSets000.FOLLOW_ruleConnector_in_ruleComplexComponent420);
            	    lv_internalConnectors_19_0=ruleConnector();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getComplexComponentRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"internalConnectors",
            	            		lv_internalConnectors_19_0, 
            	            		"Connector");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop3;
                }
            } while (true);

            otherlv_20=(Token)match(input,15,FollowSets000.FOLLOW_15_in_ruleComplexComponent434); 

                	newLeafNode(otherlv_20, grammarAccess.getComplexComponentAccess().getRightCurlyBracketKeyword_17());
                
            otherlv_21=(Token)match(input,15,FollowSets000.FOLLOW_15_in_ruleComplexComponent446); 

                	newLeafNode(otherlv_21, grammarAccess.getComplexComponentAccess().getRightCurlyBracketKeyword_18());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleComplexComponent"


    // $ANTLR start "entryRuleComponent"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:274:1: entryRuleComponent returns [EObject current=null] : iv_ruleComponent= ruleComponent EOF ;
    public final EObject entryRuleComponent() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleComponent = null;


        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:275:2: (iv_ruleComponent= ruleComponent EOF )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:276:2: iv_ruleComponent= ruleComponent EOF
            {
             newCompositeNode(grammarAccess.getComponentRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleComponent_in_entryRuleComponent482);
            iv_ruleComponent=ruleComponent();

            state._fsp--;

             current =iv_ruleComponent; 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleComponent492); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleComponent"


    // $ANTLR start "ruleComponent"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:283:1: ruleComponent returns [EObject current=null] : (this_SimpleComponent_0= ruleSimpleComponent | this_ComplexComponent_1= ruleComplexComponent ) ;
    public final EObject ruleComponent() throws RecognitionException {
        EObject current = null;

        EObject this_SimpleComponent_0 = null;

        EObject this_ComplexComponent_1 = null;


         enterRule(); 
            
        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:286:28: ( (this_SimpleComponent_0= ruleSimpleComponent | this_ComplexComponent_1= ruleComplexComponent ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:287:1: (this_SimpleComponent_0= ruleSimpleComponent | this_ComplexComponent_1= ruleComplexComponent )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:287:1: (this_SimpleComponent_0= ruleSimpleComponent | this_ComplexComponent_1= ruleComplexComponent )
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==22) ) {
                alt4=1;
            }
            else if ( (LA4_0==11) ) {
                alt4=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 4, 0, input);

                throw nvae;
            }
            switch (alt4) {
                case 1 :
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:288:5: this_SimpleComponent_0= ruleSimpleComponent
                    {
                     
                            newCompositeNode(grammarAccess.getComponentAccess().getSimpleComponentParserRuleCall_0()); 
                        
                    pushFollow(FollowSets000.FOLLOW_ruleSimpleComponent_in_ruleComponent539);
                    this_SimpleComponent_0=ruleSimpleComponent();

                    state._fsp--;

                     
                            current = this_SimpleComponent_0; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 2 :
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:298:5: this_ComplexComponent_1= ruleComplexComponent
                    {
                     
                            newCompositeNode(grammarAccess.getComponentAccess().getComplexComponentParserRuleCall_1()); 
                        
                    pushFollow(FollowSets000.FOLLOW_ruleComplexComponent_in_ruleComponent566);
                    this_ComplexComponent_1=ruleComplexComponent();

                    state._fsp--;

                     
                            current = this_ComplexComponent_1; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleComponent"


    // $ANTLR start "entryRuleInterface"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:314:1: entryRuleInterface returns [EObject current=null] : iv_ruleInterface= ruleInterface EOF ;
    public final EObject entryRuleInterface() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleInterface = null;


        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:315:2: (iv_ruleInterface= ruleInterface EOF )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:316:2: iv_ruleInterface= ruleInterface EOF
            {
             newCompositeNode(grammarAccess.getInterfaceRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleInterface_in_entryRuleInterface601);
            iv_ruleInterface=ruleInterface();

            state._fsp--;

             current =iv_ruleInterface; 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleInterface611); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleInterface"


    // $ANTLR start "ruleInterface"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:323:1: ruleInterface returns [EObject current=null] : (this_RequiredInterface_0= ruleRequiredInterface | this_ProvidedInterface_1= ruleProvidedInterface ) ;
    public final EObject ruleInterface() throws RecognitionException {
        EObject current = null;

        EObject this_RequiredInterface_0 = null;

        EObject this_ProvidedInterface_1 = null;


         enterRule(); 
            
        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:326:28: ( (this_RequiredInterface_0= ruleRequiredInterface | this_ProvidedInterface_1= ruleProvidedInterface ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:327:1: (this_RequiredInterface_0= ruleRequiredInterface | this_ProvidedInterface_1= ruleProvidedInterface )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:327:1: (this_RequiredInterface_0= ruleRequiredInterface | this_ProvidedInterface_1= ruleProvidedInterface )
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==20) ) {
                alt5=1;
            }
            else if ( (LA5_0==21) ) {
                alt5=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 5, 0, input);

                throw nvae;
            }
            switch (alt5) {
                case 1 :
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:328:5: this_RequiredInterface_0= ruleRequiredInterface
                    {
                     
                            newCompositeNode(grammarAccess.getInterfaceAccess().getRequiredInterfaceParserRuleCall_0()); 
                        
                    pushFollow(FollowSets000.FOLLOW_ruleRequiredInterface_in_ruleInterface658);
                    this_RequiredInterface_0=ruleRequiredInterface();

                    state._fsp--;

                     
                            current = this_RequiredInterface_0; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 2 :
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:338:5: this_ProvidedInterface_1= ruleProvidedInterface
                    {
                     
                            newCompositeNode(grammarAccess.getInterfaceAccess().getProvidedInterfaceParserRuleCall_1()); 
                        
                    pushFollow(FollowSets000.FOLLOW_ruleProvidedInterface_in_ruleInterface685);
                    this_ProvidedInterface_1=ruleProvidedInterface();

                    state._fsp--;

                     
                            current = this_ProvidedInterface_1; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleInterface"


    // $ANTLR start "entryRuleEString"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:354:1: entryRuleEString returns [String current=null] : iv_ruleEString= ruleEString EOF ;
    public final String entryRuleEString() throws RecognitionException {
        String current = null;

        AntlrDatatypeRuleToken iv_ruleEString = null;


        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:355:2: (iv_ruleEString= ruleEString EOF )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:356:2: iv_ruleEString= ruleEString EOF
            {
             newCompositeNode(grammarAccess.getEStringRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleEString_in_entryRuleEString721);
            iv_ruleEString=ruleEString();

            state._fsp--;

             current =iv_ruleEString.getText(); 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleEString732); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleEString"


    // $ANTLR start "ruleEString"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:363:1: ruleEString returns [AntlrDatatypeRuleToken current=new AntlrDatatypeRuleToken()] : (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID ) ;
    public final AntlrDatatypeRuleToken ruleEString() throws RecognitionException {
        AntlrDatatypeRuleToken current = new AntlrDatatypeRuleToken();

        Token this_STRING_0=null;
        Token this_ID_1=null;

         enterRule(); 
            
        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:366:28: ( (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:367:1: (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:367:1: (this_STRING_0= RULE_STRING | this_ID_1= RULE_ID )
            int alt6=2;
            int LA6_0 = input.LA(1);

            if ( (LA6_0==RULE_STRING) ) {
                alt6=1;
            }
            else if ( (LA6_0==RULE_ID) ) {
                alt6=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 6, 0, input);

                throw nvae;
            }
            switch (alt6) {
                case 1 :
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:367:6: this_STRING_0= RULE_STRING
                    {
                    this_STRING_0=(Token)match(input,RULE_STRING,FollowSets000.FOLLOW_RULE_STRING_in_ruleEString772); 

                    		current.merge(this_STRING_0);
                        
                     
                        newLeafNode(this_STRING_0, grammarAccess.getEStringAccess().getSTRINGTerminalRuleCall_0()); 
                        

                    }
                    break;
                case 2 :
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:375:10: this_ID_1= RULE_ID
                    {
                    this_ID_1=(Token)match(input,RULE_ID,FollowSets000.FOLLOW_RULE_ID_in_ruleEString798); 

                    		current.merge(this_ID_1);
                        
                     
                        newLeafNode(this_ID_1, grammarAccess.getEStringAccess().getIDTerminalRuleCall_1()); 
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleEString"


    // $ANTLR start "entryRulePort"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:390:1: entryRulePort returns [EObject current=null] : iv_rulePort= rulePort EOF ;
    public final EObject entryRulePort() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePort = null;


        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:391:2: (iv_rulePort= rulePort EOF )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:392:2: iv_rulePort= rulePort EOF
            {
             newCompositeNode(grammarAccess.getPortRule()); 
            pushFollow(FollowSets000.FOLLOW_rulePort_in_entryRulePort843);
            iv_rulePort=rulePort();

            state._fsp--;

             current =iv_rulePort; 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRulePort853); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePort"


    // $ANTLR start "rulePort"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:399:1: rulePort returns [EObject current=null] : ( ( (lv_name_0_0= ruleEString ) ) otherlv_1= '{' ( (lv_interfaces_2_0= ruleInterface ) ) (otherlv_3= ',' ( (lv_interfaces_4_0= ruleInterface ) ) )? otherlv_5= '}' ) ;
    public final EObject rulePort() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token otherlv_3=null;
        Token otherlv_5=null;
        AntlrDatatypeRuleToken lv_name_0_0 = null;

        EObject lv_interfaces_2_0 = null;

        EObject lv_interfaces_4_0 = null;


         enterRule(); 
            
        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:402:28: ( ( ( (lv_name_0_0= ruleEString ) ) otherlv_1= '{' ( (lv_interfaces_2_0= ruleInterface ) ) (otherlv_3= ',' ( (lv_interfaces_4_0= ruleInterface ) ) )? otherlv_5= '}' ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:403:1: ( ( (lv_name_0_0= ruleEString ) ) otherlv_1= '{' ( (lv_interfaces_2_0= ruleInterface ) ) (otherlv_3= ',' ( (lv_interfaces_4_0= ruleInterface ) ) )? otherlv_5= '}' )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:403:1: ( ( (lv_name_0_0= ruleEString ) ) otherlv_1= '{' ( (lv_interfaces_2_0= ruleInterface ) ) (otherlv_3= ',' ( (lv_interfaces_4_0= ruleInterface ) ) )? otherlv_5= '}' )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:403:2: ( (lv_name_0_0= ruleEString ) ) otherlv_1= '{' ( (lv_interfaces_2_0= ruleInterface ) ) (otherlv_3= ',' ( (lv_interfaces_4_0= ruleInterface ) ) )? otherlv_5= '}'
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:403:2: ( (lv_name_0_0= ruleEString ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:404:1: (lv_name_0_0= ruleEString )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:404:1: (lv_name_0_0= ruleEString )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:405:3: lv_name_0_0= ruleEString
            {
             
            	        newCompositeNode(grammarAccess.getPortAccess().getNameEStringParserRuleCall_0_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleEString_in_rulePort899);
            lv_name_0_0=ruleEString();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getPortRule());
            	        }
                   		set(
                   			current, 
                   			"name",
                    		lv_name_0_0, 
                    		"EString");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_1=(Token)match(input,12,FollowSets000.FOLLOW_12_in_rulePort911); 

                	newLeafNode(otherlv_1, grammarAccess.getPortAccess().getLeftCurlyBracketKeyword_1());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:425:1: ( (lv_interfaces_2_0= ruleInterface ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:426:1: (lv_interfaces_2_0= ruleInterface )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:426:1: (lv_interfaces_2_0= ruleInterface )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:427:3: lv_interfaces_2_0= ruleInterface
            {
             
            	        newCompositeNode(grammarAccess.getPortAccess().getInterfacesInterfaceParserRuleCall_2_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleInterface_in_rulePort932);
            lv_interfaces_2_0=ruleInterface();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getPortRule());
            	        }
                   		add(
                   			current, 
                   			"interfaces",
                    		lv_interfaces_2_0, 
                    		"Interface");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:443:2: (otherlv_3= ',' ( (lv_interfaces_4_0= ruleInterface ) ) )?
            int alt7=2;
            int LA7_0 = input.LA(1);

            if ( (LA7_0==14) ) {
                alt7=1;
            }
            switch (alt7) {
                case 1 :
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:443:4: otherlv_3= ',' ( (lv_interfaces_4_0= ruleInterface ) )
                    {
                    otherlv_3=(Token)match(input,14,FollowSets000.FOLLOW_14_in_rulePort945); 

                        	newLeafNode(otherlv_3, grammarAccess.getPortAccess().getCommaKeyword_3_0());
                        
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:447:1: ( (lv_interfaces_4_0= ruleInterface ) )
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:448:1: (lv_interfaces_4_0= ruleInterface )
                    {
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:448:1: (lv_interfaces_4_0= ruleInterface )
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:449:3: lv_interfaces_4_0= ruleInterface
                    {
                     
                    	        newCompositeNode(grammarAccess.getPortAccess().getInterfacesInterfaceParserRuleCall_3_1_0()); 
                    	    
                    pushFollow(FollowSets000.FOLLOW_ruleInterface_in_rulePort966);
                    lv_interfaces_4_0=ruleInterface();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getPortRule());
                    	        }
                           		add(
                           			current, 
                           			"interfaces",
                            		lv_interfaces_4_0, 
                            		"Interface");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }


                    }
                    break;

            }

            otherlv_5=(Token)match(input,15,FollowSets000.FOLLOW_15_in_rulePort980); 

                	newLeafNode(otherlv_5, grammarAccess.getPortAccess().getRightCurlyBracketKeyword_4());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePort"


    // $ANTLR start "entryRuleConnector"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:477:1: entryRuleConnector returns [EObject current=null] : iv_ruleConnector= ruleConnector EOF ;
    public final EObject entryRuleConnector() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleConnector = null;


        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:478:2: (iv_ruleConnector= ruleConnector EOF )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:479:2: iv_ruleConnector= ruleConnector EOF
            {
             newCompositeNode(grammarAccess.getConnectorRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleConnector_in_entryRuleConnector1016);
            iv_ruleConnector=ruleConnector();

            state._fsp--;

             current =iv_ruleConnector; 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleConnector1026); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleConnector"


    // $ANTLR start "ruleConnector"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:486:1: ruleConnector returns [EObject current=null] : (otherlv_0= 'Connector' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' ( ( ruleEString ) ) otherlv_4= '->' ( ( ruleEString ) ) otherlv_6= '}' ) ;
    public final EObject ruleConnector() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;


         enterRule(); 
            
        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:489:28: ( (otherlv_0= 'Connector' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' ( ( ruleEString ) ) otherlv_4= '->' ( ( ruleEString ) ) otherlv_6= '}' ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:490:1: (otherlv_0= 'Connector' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' ( ( ruleEString ) ) otherlv_4= '->' ( ( ruleEString ) ) otherlv_6= '}' )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:490:1: (otherlv_0= 'Connector' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' ( ( ruleEString ) ) otherlv_4= '->' ( ( ruleEString ) ) otherlv_6= '}' )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:490:3: otherlv_0= 'Connector' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' ( ( ruleEString ) ) otherlv_4= '->' ( ( ruleEString ) ) otherlv_6= '}'
            {
            otherlv_0=(Token)match(input,18,FollowSets000.FOLLOW_18_in_ruleConnector1063); 

                	newLeafNode(otherlv_0, grammarAccess.getConnectorAccess().getConnectorKeyword_0());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:494:1: ( (lv_name_1_0= ruleEString ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:495:1: (lv_name_1_0= ruleEString )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:495:1: (lv_name_1_0= ruleEString )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:496:3: lv_name_1_0= ruleEString
            {
             
            	        newCompositeNode(grammarAccess.getConnectorAccess().getNameEStringParserRuleCall_1_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleEString_in_ruleConnector1084);
            lv_name_1_0=ruleEString();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getConnectorRule());
            	        }
                   		set(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"EString");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_2=(Token)match(input,12,FollowSets000.FOLLOW_12_in_ruleConnector1096); 

                	newLeafNode(otherlv_2, grammarAccess.getConnectorAccess().getLeftCurlyBracketKeyword_2());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:516:1: ( ( ruleEString ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:517:1: ( ruleEString )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:517:1: ( ruleEString )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:518:3: ruleEString
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getConnectorRule());
            	        }
                    
             
            	        newCompositeNode(grammarAccess.getConnectorAccess().getSourcePortCrossReference_3_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleEString_in_ruleConnector1119);
            ruleEString();

            state._fsp--;

             
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_4=(Token)match(input,19,FollowSets000.FOLLOW_19_in_ruleConnector1131); 

                	newLeafNode(otherlv_4, grammarAccess.getConnectorAccess().getHyphenMinusGreaterThanSignKeyword_4());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:535:1: ( ( ruleEString ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:536:1: ( ruleEString )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:536:1: ( ruleEString )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:537:3: ruleEString
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getConnectorRule());
            	        }
                    
             
            	        newCompositeNode(grammarAccess.getConnectorAccess().getTargetPortCrossReference_5_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleEString_in_ruleConnector1154);
            ruleEString();

            state._fsp--;

             
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_6=(Token)match(input,15,FollowSets000.FOLLOW_15_in_ruleConnector1166); 

                	newLeafNode(otherlv_6, grammarAccess.getConnectorAccess().getRightCurlyBracketKeyword_6());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleConnector"


    // $ANTLR start "entryRuleRequiredInterface"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:562:1: entryRuleRequiredInterface returns [EObject current=null] : iv_ruleRequiredInterface= ruleRequiredInterface EOF ;
    public final EObject entryRuleRequiredInterface() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleRequiredInterface = null;


        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:563:2: (iv_ruleRequiredInterface= ruleRequiredInterface EOF )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:564:2: iv_ruleRequiredInterface= ruleRequiredInterface EOF
            {
             newCompositeNode(grammarAccess.getRequiredInterfaceRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleRequiredInterface_in_entryRuleRequiredInterface1202);
            iv_ruleRequiredInterface=ruleRequiredInterface();

            state._fsp--;

             current =iv_ruleRequiredInterface; 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleRequiredInterface1212); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleRequiredInterface"


    // $ANTLR start "ruleRequiredInterface"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:571:1: ruleRequiredInterface returns [EObject current=null] : ( () otherlv_1= 'RI' ( (lv_name_2_0= ruleEString ) ) ) ;
    public final EObject ruleRequiredInterface() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        AntlrDatatypeRuleToken lv_name_2_0 = null;


         enterRule(); 
            
        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:574:28: ( ( () otherlv_1= 'RI' ( (lv_name_2_0= ruleEString ) ) ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:575:1: ( () otherlv_1= 'RI' ( (lv_name_2_0= ruleEString ) ) )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:575:1: ( () otherlv_1= 'RI' ( (lv_name_2_0= ruleEString ) ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:575:2: () otherlv_1= 'RI' ( (lv_name_2_0= ruleEString ) )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:575:2: ()
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:576:5: 
            {

                    current = forceCreateModelElement(
                        grammarAccess.getRequiredInterfaceAccess().getRequiredInterfaceAction_0(),
                        current);
                

            }

            otherlv_1=(Token)match(input,20,FollowSets000.FOLLOW_20_in_ruleRequiredInterface1258); 

                	newLeafNode(otherlv_1, grammarAccess.getRequiredInterfaceAccess().getRIKeyword_1());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:585:1: ( (lv_name_2_0= ruleEString ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:586:1: (lv_name_2_0= ruleEString )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:586:1: (lv_name_2_0= ruleEString )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:587:3: lv_name_2_0= ruleEString
            {
             
            	        newCompositeNode(grammarAccess.getRequiredInterfaceAccess().getNameEStringParserRuleCall_2_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleEString_in_ruleRequiredInterface1279);
            lv_name_2_0=ruleEString();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getRequiredInterfaceRule());
            	        }
                   		set(
                   			current, 
                   			"name",
                    		lv_name_2_0, 
                    		"EString");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleRequiredInterface"


    // $ANTLR start "entryRuleProvidedInterface"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:611:1: entryRuleProvidedInterface returns [EObject current=null] : iv_ruleProvidedInterface= ruleProvidedInterface EOF ;
    public final EObject entryRuleProvidedInterface() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleProvidedInterface = null;


        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:612:2: (iv_ruleProvidedInterface= ruleProvidedInterface EOF )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:613:2: iv_ruleProvidedInterface= ruleProvidedInterface EOF
            {
             newCompositeNode(grammarAccess.getProvidedInterfaceRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleProvidedInterface_in_entryRuleProvidedInterface1315);
            iv_ruleProvidedInterface=ruleProvidedInterface();

            state._fsp--;

             current =iv_ruleProvidedInterface; 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleProvidedInterface1325); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleProvidedInterface"


    // $ANTLR start "ruleProvidedInterface"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:620:1: ruleProvidedInterface returns [EObject current=null] : ( () otherlv_1= 'PI' ( (lv_name_2_0= ruleEString ) ) ) ;
    public final EObject ruleProvidedInterface() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        AntlrDatatypeRuleToken lv_name_2_0 = null;


         enterRule(); 
            
        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:623:28: ( ( () otherlv_1= 'PI' ( (lv_name_2_0= ruleEString ) ) ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:624:1: ( () otherlv_1= 'PI' ( (lv_name_2_0= ruleEString ) ) )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:624:1: ( () otherlv_1= 'PI' ( (lv_name_2_0= ruleEString ) ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:624:2: () otherlv_1= 'PI' ( (lv_name_2_0= ruleEString ) )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:624:2: ()
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:625:5: 
            {

                    current = forceCreateModelElement(
                        grammarAccess.getProvidedInterfaceAccess().getProvidedInterfaceAction_0(),
                        current);
                

            }

            otherlv_1=(Token)match(input,21,FollowSets000.FOLLOW_21_in_ruleProvidedInterface1371); 

                	newLeafNode(otherlv_1, grammarAccess.getProvidedInterfaceAccess().getPIKeyword_1());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:634:1: ( (lv_name_2_0= ruleEString ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:635:1: (lv_name_2_0= ruleEString )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:635:1: (lv_name_2_0= ruleEString )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:636:3: lv_name_2_0= ruleEString
            {
             
            	        newCompositeNode(grammarAccess.getProvidedInterfaceAccess().getNameEStringParserRuleCall_2_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleEString_in_ruleProvidedInterface1392);
            lv_name_2_0=ruleEString();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getProvidedInterfaceRule());
            	        }
                   		set(
                   			current, 
                   			"name",
                    		lv_name_2_0, 
                    		"EString");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleProvidedInterface"


    // $ANTLR start "entryRuleSimpleComponent"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:660:1: entryRuleSimpleComponent returns [EObject current=null] : iv_ruleSimpleComponent= ruleSimpleComponent EOF ;
    public final EObject entryRuleSimpleComponent() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleSimpleComponent = null;


        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:661:2: (iv_ruleSimpleComponent= ruleSimpleComponent EOF )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:662:2: iv_ruleSimpleComponent= ruleSimpleComponent EOF
            {
             newCompositeNode(grammarAccess.getSimpleComponentRule()); 
            pushFollow(FollowSets000.FOLLOW_ruleSimpleComponent_in_entryRuleSimpleComponent1428);
            iv_ruleSimpleComponent=ruleSimpleComponent();

            state._fsp--;

             current =iv_ruleSimpleComponent; 
            match(input,EOF,FollowSets000.FOLLOW_EOF_in_entryRuleSimpleComponent1438); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleSimpleComponent"


    // $ANTLR start "ruleSimpleComponent"
    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:669:1: ruleSimpleComponent returns [EObject current=null] : (otherlv_0= 'SC' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' otherlv_3= 'ports' otherlv_4= '{' ( (lv_ports_5_0= rulePort ) ) (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )? otherlv_8= '}' otherlv_9= '}' ) ;
    public final EObject ruleSimpleComponent() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_6=null;
        Token otherlv_8=null;
        Token otherlv_9=null;
        AntlrDatatypeRuleToken lv_name_1_0 = null;

        EObject lv_ports_5_0 = null;

        EObject lv_ports_7_0 = null;


         enterRule(); 
            
        try {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:672:28: ( (otherlv_0= 'SC' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' otherlv_3= 'ports' otherlv_4= '{' ( (lv_ports_5_0= rulePort ) ) (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )? otherlv_8= '}' otherlv_9= '}' ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:673:1: (otherlv_0= 'SC' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' otherlv_3= 'ports' otherlv_4= '{' ( (lv_ports_5_0= rulePort ) ) (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )? otherlv_8= '}' otherlv_9= '}' )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:673:1: (otherlv_0= 'SC' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' otherlv_3= 'ports' otherlv_4= '{' ( (lv_ports_5_0= rulePort ) ) (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )? otherlv_8= '}' otherlv_9= '}' )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:673:3: otherlv_0= 'SC' ( (lv_name_1_0= ruleEString ) ) otherlv_2= '{' otherlv_3= 'ports' otherlv_4= '{' ( (lv_ports_5_0= rulePort ) ) (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )? otherlv_8= '}' otherlv_9= '}'
            {
            otherlv_0=(Token)match(input,22,FollowSets000.FOLLOW_22_in_ruleSimpleComponent1475); 

                	newLeafNode(otherlv_0, grammarAccess.getSimpleComponentAccess().getSCKeyword_0());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:677:1: ( (lv_name_1_0= ruleEString ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:678:1: (lv_name_1_0= ruleEString )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:678:1: (lv_name_1_0= ruleEString )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:679:3: lv_name_1_0= ruleEString
            {
             
            	        newCompositeNode(grammarAccess.getSimpleComponentAccess().getNameEStringParserRuleCall_1_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_ruleEString_in_ruleSimpleComponent1496);
            lv_name_1_0=ruleEString();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSimpleComponentRule());
            	        }
                   		set(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"EString");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_2=(Token)match(input,12,FollowSets000.FOLLOW_12_in_ruleSimpleComponent1508); 

                	newLeafNode(otherlv_2, grammarAccess.getSimpleComponentAccess().getLeftCurlyBracketKeyword_2());
                
            otherlv_3=(Token)match(input,13,FollowSets000.FOLLOW_13_in_ruleSimpleComponent1520); 

                	newLeafNode(otherlv_3, grammarAccess.getSimpleComponentAccess().getPortsKeyword_3());
                
            otherlv_4=(Token)match(input,12,FollowSets000.FOLLOW_12_in_ruleSimpleComponent1532); 

                	newLeafNode(otherlv_4, grammarAccess.getSimpleComponentAccess().getLeftCurlyBracketKeyword_4());
                
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:707:1: ( (lv_ports_5_0= rulePort ) )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:708:1: (lv_ports_5_0= rulePort )
            {
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:708:1: (lv_ports_5_0= rulePort )
            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:709:3: lv_ports_5_0= rulePort
            {
             
            	        newCompositeNode(grammarAccess.getSimpleComponentAccess().getPortsPortParserRuleCall_5_0()); 
            	    
            pushFollow(FollowSets000.FOLLOW_rulePort_in_ruleSimpleComponent1553);
            lv_ports_5_0=rulePort();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getSimpleComponentRule());
            	        }
                   		add(
                   			current, 
                   			"ports",
                    		lv_ports_5_0, 
                    		"Port");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:725:2: (otherlv_6= ',' ( (lv_ports_7_0= rulePort ) ) )?
            int alt8=2;
            int LA8_0 = input.LA(1);

            if ( (LA8_0==14) ) {
                alt8=1;
            }
            switch (alt8) {
                case 1 :
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:725:4: otherlv_6= ',' ( (lv_ports_7_0= rulePort ) )
                    {
                    otherlv_6=(Token)match(input,14,FollowSets000.FOLLOW_14_in_ruleSimpleComponent1566); 

                        	newLeafNode(otherlv_6, grammarAccess.getSimpleComponentAccess().getCommaKeyword_6_0());
                        
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:729:1: ( (lv_ports_7_0= rulePort ) )
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:730:1: (lv_ports_7_0= rulePort )
                    {
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:730:1: (lv_ports_7_0= rulePort )
                    // ../org.xtext.componentMM_v2/src-gen/org/xtextcomponentMM_v2/parser/antlr/internal/InternalMmv2.g:731:3: lv_ports_7_0= rulePort
                    {
                     
                    	        newCompositeNode(grammarAccess.getSimpleComponentAccess().getPortsPortParserRuleCall_6_1_0()); 
                    	    
                    pushFollow(FollowSets000.FOLLOW_rulePort_in_ruleSimpleComponent1587);
                    lv_ports_7_0=rulePort();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getSimpleComponentRule());
                    	        }
                           		add(
                           			current, 
                           			"ports",
                            		lv_ports_7_0, 
                            		"Port");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }


                    }
                    break;

            }

            otherlv_8=(Token)match(input,15,FollowSets000.FOLLOW_15_in_ruleSimpleComponent1601); 

                	newLeafNode(otherlv_8, grammarAccess.getSimpleComponentAccess().getRightCurlyBracketKeyword_7());
                
            otherlv_9=(Token)match(input,15,FollowSets000.FOLLOW_15_in_ruleSimpleComponent1613); 

                	newLeafNode(otherlv_9, grammarAccess.getSimpleComponentAccess().getRightCurlyBracketKeyword_8());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleSimpleComponent"

    // Delegated rules


 

    
    private static class FollowSets000 {
        public static final BitSet FOLLOW_ruleComplexComponent_in_entryRuleComplexComponent75 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleComplexComponent85 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_11_in_ruleComplexComponent122 = new BitSet(new long[]{0x0000000000000030L});
        public static final BitSet FOLLOW_ruleEString_in_ruleComplexComponent143 = new BitSet(new long[]{0x0000000000001000L});
        public static final BitSet FOLLOW_12_in_ruleComplexComponent155 = new BitSet(new long[]{0x0000000000002000L});
        public static final BitSet FOLLOW_13_in_ruleComplexComponent167 = new BitSet(new long[]{0x0000000000001000L});
        public static final BitSet FOLLOW_12_in_ruleComplexComponent179 = new BitSet(new long[]{0x0000000000000030L});
        public static final BitSet FOLLOW_rulePort_in_ruleComplexComponent200 = new BitSet(new long[]{0x000000000000C000L});
        public static final BitSet FOLLOW_14_in_ruleComplexComponent213 = new BitSet(new long[]{0x0000000000000030L});
        public static final BitSet FOLLOW_rulePort_in_ruleComplexComponent234 = new BitSet(new long[]{0x0000000000008000L});
        public static final BitSet FOLLOW_15_in_ruleComplexComponent248 = new BitSet(new long[]{0x0000000000010000L});
        public static final BitSet FOLLOW_16_in_ruleComplexComponent260 = new BitSet(new long[]{0x0000000000001000L});
        public static final BitSet FOLLOW_12_in_ruleComplexComponent272 = new BitSet(new long[]{0x0000000000400800L});
        public static final BitSet FOLLOW_ruleComponent_in_ruleComplexComponent293 = new BitSet(new long[]{0x000000000000C000L});
        public static final BitSet FOLLOW_14_in_ruleComplexComponent306 = new BitSet(new long[]{0x0000000000400800L});
        public static final BitSet FOLLOW_ruleComponent_in_ruleComplexComponent327 = new BitSet(new long[]{0x000000000000C000L});
        public static final BitSet FOLLOW_15_in_ruleComplexComponent341 = new BitSet(new long[]{0x0000000000020000L});
        public static final BitSet FOLLOW_17_in_ruleComplexComponent353 = new BitSet(new long[]{0x0000000000001000L});
        public static final BitSet FOLLOW_12_in_ruleComplexComponent365 = new BitSet(new long[]{0x0000000000040000L});
        public static final BitSet FOLLOW_ruleConnector_in_ruleComplexComponent386 = new BitSet(new long[]{0x000000000000C000L});
        public static final BitSet FOLLOW_14_in_ruleComplexComponent399 = new BitSet(new long[]{0x0000000000040000L});
        public static final BitSet FOLLOW_ruleConnector_in_ruleComplexComponent420 = new BitSet(new long[]{0x000000000000C000L});
        public static final BitSet FOLLOW_15_in_ruleComplexComponent434 = new BitSet(new long[]{0x0000000000008000L});
        public static final BitSet FOLLOW_15_in_ruleComplexComponent446 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleComponent_in_entryRuleComponent482 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleComponent492 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleSimpleComponent_in_ruleComponent539 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleComplexComponent_in_ruleComponent566 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleInterface_in_entryRuleInterface601 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleInterface611 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleRequiredInterface_in_ruleInterface658 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleProvidedInterface_in_ruleInterface685 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleEString_in_entryRuleEString721 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleEString732 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_RULE_STRING_in_ruleEString772 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_RULE_ID_in_ruleEString798 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_rulePort_in_entryRulePort843 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRulePort853 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleEString_in_rulePort899 = new BitSet(new long[]{0x0000000000001000L});
        public static final BitSet FOLLOW_12_in_rulePort911 = new BitSet(new long[]{0x0000000000300000L});
        public static final BitSet FOLLOW_ruleInterface_in_rulePort932 = new BitSet(new long[]{0x000000000000C000L});
        public static final BitSet FOLLOW_14_in_rulePort945 = new BitSet(new long[]{0x0000000000300000L});
        public static final BitSet FOLLOW_ruleInterface_in_rulePort966 = new BitSet(new long[]{0x0000000000008000L});
        public static final BitSet FOLLOW_15_in_rulePort980 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleConnector_in_entryRuleConnector1016 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleConnector1026 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_18_in_ruleConnector1063 = new BitSet(new long[]{0x0000000000000030L});
        public static final BitSet FOLLOW_ruleEString_in_ruleConnector1084 = new BitSet(new long[]{0x0000000000001000L});
        public static final BitSet FOLLOW_12_in_ruleConnector1096 = new BitSet(new long[]{0x0000000000000030L});
        public static final BitSet FOLLOW_ruleEString_in_ruleConnector1119 = new BitSet(new long[]{0x0000000000080000L});
        public static final BitSet FOLLOW_19_in_ruleConnector1131 = new BitSet(new long[]{0x0000000000000030L});
        public static final BitSet FOLLOW_ruleEString_in_ruleConnector1154 = new BitSet(new long[]{0x0000000000008000L});
        public static final BitSet FOLLOW_15_in_ruleConnector1166 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleRequiredInterface_in_entryRuleRequiredInterface1202 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleRequiredInterface1212 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_20_in_ruleRequiredInterface1258 = new BitSet(new long[]{0x0000000000000030L});
        public static final BitSet FOLLOW_ruleEString_in_ruleRequiredInterface1279 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleProvidedInterface_in_entryRuleProvidedInterface1315 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleProvidedInterface1325 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_21_in_ruleProvidedInterface1371 = new BitSet(new long[]{0x0000000000000030L});
        public static final BitSet FOLLOW_ruleEString_in_ruleProvidedInterface1392 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_ruleSimpleComponent_in_entryRuleSimpleComponent1428 = new BitSet(new long[]{0x0000000000000000L});
        public static final BitSet FOLLOW_EOF_in_entryRuleSimpleComponent1438 = new BitSet(new long[]{0x0000000000000002L});
        public static final BitSet FOLLOW_22_in_ruleSimpleComponent1475 = new BitSet(new long[]{0x0000000000000030L});
        public static final BitSet FOLLOW_ruleEString_in_ruleSimpleComponent1496 = new BitSet(new long[]{0x0000000000001000L});
        public static final BitSet FOLLOW_12_in_ruleSimpleComponent1508 = new BitSet(new long[]{0x0000000000002000L});
        public static final BitSet FOLLOW_13_in_ruleSimpleComponent1520 = new BitSet(new long[]{0x0000000000001000L});
        public static final BitSet FOLLOW_12_in_ruleSimpleComponent1532 = new BitSet(new long[]{0x0000000000000030L});
        public static final BitSet FOLLOW_rulePort_in_ruleSimpleComponent1553 = new BitSet(new long[]{0x000000000000C000L});
        public static final BitSet FOLLOW_14_in_ruleSimpleComponent1566 = new BitSet(new long[]{0x0000000000000030L});
        public static final BitSet FOLLOW_rulePort_in_ruleSimpleComponent1587 = new BitSet(new long[]{0x0000000000008000L});
        public static final BitSet FOLLOW_15_in_ruleSimpleComponent1601 = new BitSet(new long[]{0x0000000000008000L});
        public static final BitSet FOLLOW_15_in_ruleSimpleComponent1613 = new BitSet(new long[]{0x0000000000000002L});
    }


}